<template>
  <q-page padding>
    <div class="col justify-center items-center">
      <div class="row justify-center items-center" style="text-align: center">
        <h4>Todos los Games</h4>
      </div>

      <div class="row justify-center items-center">
        <q-list bordered separator style="width: 85%">
          <q-item v-for=" game in games " v-bind:key="game.name" clickable v-ripple>
            <q-item-section avatar>
              <q-avatar color="primary" text-color="white">{{game.name.charAt(0).toUpperCase()}}</q-avatar>
            </q-item-section>

            <q-item-section>
              <q-item-label>{{game.name}}</q-item-label>
            </q-item-section>

            <q-item-section side>
              <div class="row">
                <q-btn
                  @click="edit = true; gameToUpdate=game"
                  color="secondary"
                  size="12px"
                  flat
                  dense
                  round
                  icon="edit"
                />
                <q-btn
                  @click="borrarGame = true; gameToDelete = game.id"
                  color="red"
                  size="12px"
                  flat
                  dense
                  round
                  icon="delete"
                />
              </div>
            </q-item-section>
          </q-item>
        </q-list>

        <q-btn @click="add= true" class="plus" fab icon="add" color="accent" />

        <q-dialog v-model="borrarGame">
          <q-card>
            <q-card-section class="row items-center">
              <q-avatar icon="delete" color="primary" text-color="white" />
              <span class="q-ml-sm">¿Está seguro que desea eliminar este game?</span>
            </q-card-section>

            <q-card-actions align="right">
              <q-btn flat label="No" color="primary" v-close-popup />
              <q-btn @click="borrar" flat label="Si, mándale mecha" color="primary" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>

        <q-dialog v-model="edit">
          <q-card style="min-width: 350px">
            <q-card-section>
              <div class="text-h6">Editar Game</div>
            </q-card-section>

            <q-card-section>
              <q-input
                rounded
                outlined
                v-model="name"
                label="Nombre"
                lazy-rules
                :rules="[ val => val && val.length > 0 || 'Ingrese un usuario']"
              >
                <template v-slot:prepend>
                  <q-icon name="gamepad" />
                </template>
              </q-input>
            </q-card-section>

            <q-card-actions align="right" class="text-primary">
              <q-btn flat label="Cerrar" v-close-popup />
              <q-btn @click="editar" flat label="Editar" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>
        <q-dialog v-model="add">
          <q-card style="min-width: 350px">
            <q-card-section>
              <div class="text-h6">Agregar Game</div>
            </q-card-section>

            <q-input
              rounded
              outlined
              v-model="name"
              label="Nombre"
              lazy-rules
              :rules="[ val => val && val.length > 0 || 'Ingrese un usuario']"
            >
              <template v-slot:prepend>
                <q-icon name="gamepad" />
              </template>
            </q-input>

            <q-card-actions align="right" class="text-primary">
              <q-btn flat label="Cerrar" v-close-popup />
              <q-btn @click="addGame" flat label="Agregar" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>
      </div>
    </div>
  </q-page>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      games: [],
      borrarGame: false,
      edit: false,
      add: false,
      gameToDelete: null,
      gameToUpdate: null,
      name: null
    };
  },
  methods: {
    reload() {
      axios
        .get("http://10.0.2.2:5000/api/game/")
        .then(response => (this.games = response.data));
    },

    addGame() {
      axios
        .post("http://10.0.2.2:5000/api/game/", {
          name: this.name
        })
        .then(response => {
          this.$q.notify("Juego creado con exito");
          this.reload();
        });
    },

    borrar() {
      axios
        .delete("http://10.0.2.2:5000/api/game/" + this.gameToDelete)
        .then(response => {
          this.$q.notify("Juego eliminado con exito");
          this.reload();
        });
    },

    editar(){
            axios
            .put("http://10.0.2.2:5000/api/game/"+this.gameToUpdate.id,{name:this.name})
             .then(response => {
          this.$q.notify("Game editado con exito");
          this.reload();
        });
    }
  },
  mounted() {
    axios;
    this.reload();
  }
};
</script>



<style scoped>
.plus {
  position: absolute;
  bottom: 30px;
  right: 32px;
}
</style>    